import tensorflow as tf
import numpy as np
import pandas as pd
import os

print("TensorFlow version:", tf.__version__)

batch_size = 128
img_height = 224
img_width = 224

num_classes = 4

crosses=[
    "prod_cis1",
    "prod_cis2",
    "prod_cis3",
    "prod_cis4",
    "prod_cis5",
    "prod_cis6",
    "prod_trans1",
    "prod_trans2",
    "prod_trans3",
    "prod_trans4",
    "prod_trans5",
    "prod_trans6"
    ]

# higher_dirs=[
# "O:/Tech_TTH-KBE/RangeX/2021/Drakensberg/high/",
# "O:/Tech_TTH-KBE/RangeX/2021/Drakensberg/low/",
# "O:/Tech_TTH-KBE/RangeX/2021/Calanda/high/",
# "O:/Tech_TTH-KBE/RangeX/2021/Calanda/low/",
# ]

higher_dirs=[
"O:/Tech_TTH-Lab/Jamie/Weather detector/Images/BJOR-2020/BJOR-01/",
"O:/Tech_TTH-Lab/Jamie/Weather detector/Images/BJOR-2020/BJOR-03/",
"O:/Tech_TTH-Lab/Jamie/Weather detector/Images/BJOR-2020/BJOR-04/",
"O:/Tech_TTH-Lab/Jamie/Weather detector/Images/BJOR-2020/BJOR-05/",
"O:/Tech_TTH-Lab/Jamie/Weather detector/Images/BJOR-2020/BJOR-09/",
"O:/Tech_TTH-Lab/Jamie/Weather detector/Images/BJOR-2020/BJOR-11/"
]

for cross in crosses:
    
    model = tf.keras.models.load_model("O:/Tech_ECE-Cluster/jagger/models/"+cross+"_best_model")

    for higher_dir in higher_dirs:
    
        cams=os.listdir(higher_dir)
        print(cams)
    
        for cam in cams:
            eval_dir=higher_dir+cam
    
            test_ds = tf.keras.utils.image_dataset_from_directory(
              eval_dir,
              seed=123,
              shuffle=False,
              labels=None,
              image_size=(img_height, img_width),
              batch_size=batch_size)
    
            predictions = model.predict(test_ds)
            print(predictions)
            ds_files = test_ds.file_paths
            print(len(ds_files))
            print(ds_files[0:5])
            print(predictions[0:5])
            pred_df=pd.DataFrame(predictions,columns=["background","hail","snow","sunshine"])
            pred_df["path"]=ds_files
            pred=[]
            for item in predictions:
              pred.append(["background","hail","snow","sunshine"][np.argmax(item)])
            pred_df["pred"]=pred
            pred_df.to_csv("O:/Tech_TTH-Lab/Jamie/RangeX/Documents/Weather/prediction/"+cross+"_"+cam+"_pred_df.csv")