%   Edited Matlab code from the site https://jiaya.me/projects/weatherclassify/index.htm in relation to the papers by Lu et al., cited fully in the manuscript
%   After clicking the "Matlab executable" link and downloading the "weather_release" folder, this script can be added to the downloaded folder and run from there for alternative sunny vs. cloudy predictions

cams=["BJOR-01","BJOR-03","BJOR-04","BJOR-05","BJOR-09","BJOR-11"]

for c = 1:length(cams)
    cam=cams(c)
    folder=strcat('O:/Tech_TTH-Lab/Jamie/Weather detector/Images/BJOR-2020/',cam,'/',cam,'/')
    imlistraw = dir(folder)
    imlist = imlistraw(endsWith({imlistraw.name}, '.JPG'));
    
    % Step 1: Create an empty table with variable names and data types
    filename = [];  % Define your variable names and data types
    pred = [];
    myTable = table(filename, pred);
    
    for i = 1:length(imlist)
        if imlist(i).isdir==1;
            continue
        end
        thisfnm=imlist(i).name
        im = im2double(imread(strcat(folder,thisfnm)));
        [label, score] = weather_predict(im); % score is resulting SVM score.
        if label == 1
            thislbl = "background";
        else
            thislbl = "sunshine";
        end
        newRow = {thisfnm, thislbl};
        myTable = [myTable; newRow];
    end
    table_out=strcat('O:/Tech_TTH-Lab/Jamie/RangeX/Documents/Weather/prediction/lu_et_al_',cam,'_pred_df.csv');
    writetable(myTable, table_out);
end